
/*  A Bison parser, made from gram.y with Bison version GNU Bison version 1.21
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	AND	258
#define	ARRAY	259
#define	BEGIn	260
#define	CASE	261
#define	CONST	262
#define	DIV	263
#define	DO	264
#define	DOWNTO	265
#define	ELSE	266
#define	END	267
#define	FILe	268
#define	FOR	269
#define	FORWARD	270
#define	FUNCTION	271
#define	GOTO	272
#define	IF	273
#define	IN	274
#define	LABEL	275
#define	MOD	276
#define	NIL	277
#define	NOT	278
#define	OF	279
#define	OR	280
#define	PACKED	281
#define	PROCEDURE	282
#define	PROGRAM	283
#define	RECORD	284
#define	REPEAT	285
#define	SET	286
#define	THEN	287
#define	TO	288
#define	TYPE	289
#define	UNTIL	290
#define	VAR	291
#define	WHILE	292
#define	WITH	293
#define	READ	294
#define	READLN	295
#define	OTHERS	296
#define	DOTDOT	297
#define	NEQ	298
#define	GEQ	299
#define	LEQ	300
#define	ASSIGN	301
#define	PASCAL_KEYWORD	302
#define	TYPE_IDENTIFIER	303
#define	FIELD_IDENTIFIER	304
#define	C_RESERVED	305
#define	CONSTANT_IDENTIFIER	306
#define	FUNCTION_IDENTIFIER	307
#define	PROCEDURE_IDENTIFIER	308
#define	UNDEFINED_IDENTIFIER	309
#define	VARIABLE_IDENTIFIER	310
#define	PARAMETER_IDENTIFIER	311
#define	WRITE	312
#define	WRITELN	313
#define	BUILD_IN_IDENTIFIER	314
#define	CHARACTER_STRING	315
#define	CHARACTER_CONSTANT	316
#define	UNSIGNED_NUMBER	317
#define	REAL_CONSTANT	318
#define	LONG_REAL_CONSTANT	319
#define	IDENTIFIER	320

#line 21 "gram.y"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "common.h"

unsigned block_level;
symbol_t *prog_symbol;

static unsigned last_type;
static void *last_type_ptr;
static value_t last_value;
static array_node *last_array_node;
static array_node *array_type_stack[20];
static unsigned array_type_stack_ptr;
static parameter_node *parameter_node_stack[20];
static unsigned parameter_node_stack_ptr;
static declarator_node *last_declarator;
static parameter_node *last_parameter;
static int by_reference;
static record_section_node *last_record_section;
static variant_node *last_variant;

static char file_spec[128];
static int file_specified;
static unsigned file_type;
static unsigned buf_mark;
static unsigned buf_mark2;
static int to_eoln;

static int saw_assign;

static unsigned routine_handle;

#define push_array_type(arr)					      \
  if (array_type_stack_ptr+1 == 20)				      \
    c4p_error ("too many nested array accesses");		      \
  array_type_stack[ array_type_stack_ptr++ ] = last_array_node;	      \
  last_array_node = arr

#define pop_array_type()					      \
  if (array_type_stack_ptr-- == 0)				      \
    c4p_error ("internal error: pop_array_type()");		      \
  last_array_node = array_type_stack[ array_type_stack_ptr ]

#define push_parameter_node(par)				      \
  if (parameter_node_stack_ptr+1 == 20)				      \
    c4p_error ("too many nested function calls");		      \
  parameter_node_stack[ parameter_node_stack_ptr++ ] = par

#define pop_parameter_node(par)					      \
  if (parameter_node_stack_ptr-- == 0)				      \
    c4p_error ("internal error: pop_parameter_node()");		      \
  par = parameter_node_stack[ parameter_node_stack_ptr ]

#define get_array_offset(arr)  arr->lower_bound


#line 82 "gram.y"
typedef union {
  symbol_t *sym;
  long value;
  double fvalue;
  void * type_ptr;
  unsigned buf_mark;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		440
#define	YYFLAG		-32768
#define	YYNTBASE	82

#define YYTRANSLATE(x) ((unsigned)(x) <= 320 ? yytranslate[x] : 265)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    68,
    69,    81,    73,    70,    74,    67,    80,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    71,    66,    78,
    72,    79,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    75,     2,    76,    77,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     5,     6,    11,    12,    16,    17,    18,    19,    29,
    35,    37,    41,    43,    44,    46,    48,    51,    53,    55,
    60,    61,    62,    75,    78,    84,    85,    86,    91,    96,
    97,    98,   111,   115,   117,   118,   123,   124,   127,   128,
   132,   136,   138,   139,   144,   146,   147,   151,   153,   157,
   158,   161,   163,   166,   167,   173,   174,   176,   178,   180,
   183,   186,   188,   191,   194,   196,   199,   202,   204,   207,
   210,   212,   214,   216,   219,   222,   224,   227,   230,   232,
   233,   236,   238,   241,   242,   248,   250,   252,   254,   256,
   258,   262,   264,   267,   269,   271,   273,   277,   278,   286,
   288,   290,   291,   296,   300,   302,   306,   309,   311,   313,
   314,   319,   320,   324,   326,   327,   332,   334,   335,   340,
   342,   344,   346,   347,   352,   353,   354,   355,   363,   366,
   367,   370,   372,   375,   380,   382,   383,   388,   390,   392,
   393,   398,   400,   404,   405,   409,   412,   413,   415,   418,
   419,   421,   423,   425,   426,   430,   431,   435,   436,   440,
   441,   445,   446,   450,   451,   453,   454,   459,   461,   462,
   467,   469,   470,   472,   473,   478,   480,   481,   486,   488,
   489,   494,   496,   497,   502,   504,   506,   508,   510,   512,
   513,   514,   522,   523,   524,   528,   529,   530,   539,   540,
   542,   544,   546,   550,   551,   556,   558,   562,   563,   566,
   568,   570,   572,   574,   575,   576,   583,   584,   585,   592,
   593,   594,   595,   607,   609,   611,   613,   615,   616,   617,
   623,   626,   628,   630,   632,   634,   637,   639,   641,   643,
   645,   646,   652,   654,   658,   660,   662,   663,   668,   670,
   671,   676,   678,   680,   682,   684,   686,   688,   690,   692,
   693,   697,   700,   701,   706,   707,   712,   714,   716,   718,
   719,   724,   725,   730,   731,   736,   738,   740,   742,   744,
   746,   748,   750,   752,   754,   755,   761,   762,   767,   768,
   772,   773,   777,   779,   780,   785,   786
};

static const short yyrhs[] = {    83,
    66,    86,    67,     0,     0,    28,    65,    84,    85,     0,
     0,    68,    90,    69,     0,     0,     0,     0,    87,   114,
   116,   122,   157,    88,    92,    89,   163,     0,   114,   116,
   122,   157,   163,     0,    91,     0,    90,    70,    91,     0,
    65,     0,     0,    93,     0,    94,     0,    93,    94,     0,
   101,     0,    95,     0,    98,    66,    15,    66,     0,     0,
     0,    98,    66,    96,   114,   116,   122,   157,     5,    97,
   166,    12,    66,     0,    16,    65,     0,    16,    65,    99,
    71,    65,     0,     0,     0,    68,   100,   105,    69,     0,
   104,    66,    15,    66,     0,     0,     0,   104,    66,   102,
   114,   116,   122,   157,     5,   103,   166,    12,    66,     0,
    27,    65,    99,     0,   107,     0,     0,   105,    66,   106,
   107,     0,     0,   108,   110,     0,     0,    36,   109,   110,
     0,   111,    71,    65,     0,   113,     0,     0,   111,    70,
   112,   113,     0,    65,     0,     0,    20,   115,    66,     0,
    62,     0,   115,    70,    62,     0,     0,     7,   117,     0,
   118,     0,   117,   118,     0,     0,    65,    72,   119,   120,
    66,     0,     0,    73,     0,    74,     0,    63,     0,    73,
    63,     0,    74,    63,     0,    64,     0,    73,    64,     0,
    74,    63,     0,    62,     0,    73,    62,     0,    74,    62,
     0,    65,     0,    73,    65,     0,    74,    65,     0,    60,
     0,    61,     0,    62,     0,    73,    62,     0,    74,    62,
     0,    65,     0,    73,    65,     0,    74,    65,     0,    61,
     0,     0,    34,   123,     0,   124,     0,   123,   124,     0,
     0,    65,    72,   125,   126,    66,     0,    65,     0,   127,
     0,   128,     0,   130,     0,   129,     0,   121,    42,   121,
     0,   131,     0,    26,   131,     0,   133,     0,   139,     0,
   132,     0,    13,    24,   135,     0,     0,     4,    75,   136,
    76,    24,   134,   135,     0,   126,     0,   138,     0,     0,
   136,    70,   137,   138,     0,   121,    42,   121,     0,    65,
     0,    29,   140,    12,     0,   141,   148,     0,   142,     0,
   144,     0,     0,   142,    66,   143,   144,     0,     0,   145,
    71,   126,     0,   147,     0,     0,   145,    70,   146,   147,
     0,    65,     0,     0,     6,   149,    24,   151,     0,   150,
     0,    65,     0,   153,     0,     0,   151,    66,   152,   153,
     0,     0,     0,     0,   154,   208,    71,    68,   155,   156,
    69,     0,   141,   148,     0,     0,    36,   158,     0,   159,
     0,   158,   159,     0,   160,    71,   126,    66,     0,   162,
     0,     0,   160,    70,   161,   162,     0,    65,     0,   164,
     0,     0,     5,   165,   166,    12,     0,   167,     0,   166,
    66,   167,     0,     0,   169,   168,   171,     0,   169,   193,
     0,     0,   170,     0,    62,    71,     0,     0,   225,     0,
   172,     0,   228,     0,     0,    39,   173,   179,     0,     0,
    40,   174,   178,     0,     0,    57,   175,   185,     0,     0,
    58,   176,   184,     0,     0,    65,   177,   260,     0,     0,
   179,     0,     0,    68,   180,   181,    69,     0,   183,     0,
     0,   181,    70,   182,   183,     0,   230,     0,     0,   185,
     0,     0,    68,   186,   187,    69,     0,   189,     0,     0,
   187,    70,   188,   189,     0,   242,     0,     0,   242,    71,
   190,   191,     0,   242,     0,     0,   242,    71,   192,   242,
     0,   164,     0,   194,     0,   211,     0,   195,     0,   200,
     0,     0,     0,    18,   196,   244,    32,   197,   167,   198,
     0,     0,     0,    11,   199,   167,     0,     0,     0,     6,
   201,   204,    24,   202,   205,   203,    12,     0,     0,    66,
     0,   242,     0,   206,     0,   205,    66,   206,     0,     0,
   208,    71,   207,   167,     0,   209,     0,   208,    70,   209,
     0,     0,   210,   120,     0,    41,     0,   215,     0,   212,
     0,   218,     0,     0,     0,    37,   213,   242,     9,   214,
   167,     0,     0,     0,    30,   216,   166,    35,   217,   242,
     0,     0,     0,     0,    14,    65,    46,   219,   222,   224,
   220,   223,     9,   221,   167,     0,   242,     0,   242,     0,
    33,     0,    10,     0,     0,     0,   230,   226,   229,   227,
   242,     0,    17,    62,     0,    46,     0,   232,     0,   234,
     0,   231,     0,   230,    77,     0,   233,     0,    65,     0,
   235,     0,   238,     0,     0,   237,    75,   236,   240,    76,
     0,   230,     0,   239,    67,    65,     0,   230,     0,   242,
     0,     0,   240,    70,   241,   242,     0,   246,     0,     0,
   242,   245,   243,   246,     0,   242,     0,    78,     0,    79,
     0,    45,     0,    44,     0,    72,     0,    43,     0,   251,
     0,     0,    74,   247,   251,     0,    73,   251,     0,     0,
   246,   250,   248,   251,     0,     0,   246,    25,   249,   251,
     0,    74,     0,    73,     0,   256,     0,     0,   251,    80,
   252,   256,     0,     0,   251,   255,   253,   256,     0,     0,
   251,     3,   254,   256,     0,    81,     0,     8,     0,    21,
     0,    62,     0,    63,     0,    64,     0,    60,     0,    61,
     0,   230,     0,     0,    65,    68,   257,   261,    69,     0,
     0,    68,   258,   242,    69,     0,     0,    23,   259,   256,
     0,     0,    68,   261,    69,     0,   263,     0,     0,   261,
    70,   262,   263,     0,     0,   264,   242,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   128,   131,   139,   141,   143,   146,   151,   158,   166,   174,
   185,   187,   190,   196,   198,   201,   203,   206,   211,   217,
   221,   227,   240,   249,   256,   270,   275,   279,   286,   290,
   296,   303,   310,   331,   333,   338,   344,   349,   352,   357,
   366,   386,   388,   393,   399,   407,   409,   413,   417,   420,
   422,   426,   428,   431,   436,   444,   446,   447,   450,   457,
   463,   469,   475,   481,   488,   494,   500,   506,   515,   524,
   536,   544,   554,   556,   560,   564,   571,   578,   585,   588,
   590,   593,   595,   598,   603,   610,   618,   621,   623,   629,
   636,   644,   646,   652,   654,   655,   661,   669,   675,   683,
   687,   689,   694,   701,   707,   741,   749,   756,   760,   762,
   767,   773,   778,   785,   787,   792,   798,   806,   811,   817,
   824,   830,   832,   837,   843,   848,   852,   856,   863,   870,
   872,   875,   877,   880,   891,   893,   898,   904,   912,   916,
   929,   941,   943,   946,   952,   952,   955,   957,   960,   967,
   972,   973,   974,   977,   983,   983,   988,   988,   993,   993,
   998,   998,  1009,  1015,  1020,  1023,  1036,  1047,  1049,  1056,
  1058,  1089,  1094,  1097,  1110,  1121,  1123,  1130,  1132,  1163,
  1185,  1187,  1191,  1196,  1201,  1203,  1204,  1210,  1212,  1216,
  1221,  1226,  1229,  1234,  1241,  1246,  1251,  1256,  1263,  1265,
  1268,  1274,  1276,  1279,  1285,  1291,  1293,  1296,  1301,  1304,
  1311,  1313,  1314,  1317,  1322,  1328,  1333,  1339,  1345,  1351,
  1356,  1360,  1366,  1374,  1380,  1386,  1391,  1397,  1406,  1411,
  1416,  1423,  1427,  1429,  1433,  1436,  1447,  1451,  1482,  1484,
  1487,  1496,  1505,  1509,  1518,  1522,  1530,  1535,  1543,  1545,
  1551,  1560,  1564,  1569,  1573,  1577,  1581,  1585,  1591,  1593,
  1598,  1601,  1605,  1611,  1618,  1623,  1625,  1630,  1636,  1638,
  1643,  1643,  1649,  1656,  1661,  1663,  1668,  1672,  1678,  1684,
  1689,  1694,  1701,  1708,  1723,  1736,  1747,  1751,  1756,  1761,
  1766,  1768,  1771,  1773,  1778,  1780,  1787
};

static const char * const yytname[] = {   "$","error","$illegal.","AND","ARRAY",
"BEGIn","CASE","CONST","DIV","DO","DOWNTO","ELSE","END","FILe","FOR","FORWARD",
"FUNCTION","GOTO","IF","IN","LABEL","MOD","NIL","NOT","OF","OR","PACKED","PROCEDURE",
"PROGRAM","RECORD","REPEAT","SET","THEN","TO","TYPE","UNTIL","VAR","WHILE","WITH",
"READ","READLN","OTHERS","DOTDOT","NEQ","GEQ","LEQ","ASSIGN","PASCAL_KEYWORD",
"TYPE_IDENTIFIER","FIELD_IDENTIFIER","C_RESERVED","CONSTANT_IDENTIFIER","FUNCTION_IDENTIFIER",
"PROCEDURE_IDENTIFIER","UNDEFINED_IDENTIFIER","VARIABLE_IDENTIFIER","PARAMETER_IDENTIFIER",
"WRITE","WRITELN","BUILD_IN_IDENTIFIER","CHARACTER_STRING","CHARACTER_CONSTANT",
"UNSIGNED_NUMBER","REAL_CONSTANT","LONG_REAL_CONSTANT","IDENTIFIER","';'","'.'",
"'('","')'","','","':'","'='","'+'","'-'","'['","']'","'^'","'<'","'>'","'/'",
"'*'","program","program_heading","@1","optional_program_parameters","program_block",
"@2","@3","@4","program_parameter_list","program_parameter","procedure_and_function_declaration_part",
"procedure_and_function_declarations","procedure_or_function_declaration","function_declaration",
"@5","@6","function_head","optional_formal_parameter_section_list","@7","procedure_declaration",
"@8","@9","procedure_head","formal_parameter_section_list","@10","formal_parameter_section",
"@11","@12","parameter_group","parameter_declarator_list","@13","parameter_declarator",
"label_declaration_part","label_list","constant_definition_part","constant_definitions",
"constant_definition","@14","constant","bound","type_definition_part","type_definitions",
"type_definition","@15","type_denoter","type","ordinal_type","subrange_type",
"structured_type","unpacked_structured_type","file_type","array_type","@16",
"component_type","index_type_list","@17","index_type","record_type","field_list",
"fixed_part","record_section_list","@18","record_section","field_declarator_list",
"@19","field_declarator","variant_part","variant_selector","tag_type","variant_list",
"@20","variant","@21","@22","variant_field_list","variable_declaration_part",
"variable_declarations","variable_declaration","variable_declarator_list","@23",
"variable_declarator","statement_part","compound_statement","@24","statement_sequence",
"statement","@25","optional_label","label","simple_statement","procedure_statement",
"@26","@27","@28","@29","@30","readln_parameter_list","read_parameter_list",
"@31","read_parameter_list1","@32","read_parameter","writeln_parameter_list",
"write_parameter_list","@33","write_parameter_list1","@34","write_expression",
"@35","output_width","@36","structured_statement","conditional_statement","if_statement",
"@37","@38","else_part","@39","case_statement","@40","@41","optional_semicolon",
"case_index","case_list_element_sequence","case_list_element","@42","case_constant_list",
"case_constant","@43","repetitive_statement","while_statement","@44","@45","repeat_statement",
"@46","@47","for_statement","@48","@49","@50","initial_value","final_value",
"to_or_downto","assignment_statement","@51","@52","goto_statement","assign",
"variable_access","buffer_variable","entire_variable","variable_identifier",
"component_variable","indexed_variable","@53","array_variable","field_designator",
"record_variable","index_expression_list","@54","expression","@55","boolean_expression",
"relational_operator","simple_expression","@56","@57","@58","adding_operator",
"term","@59","@60","@61","multiplying_operator","factor","@62","@63","@64","optional_actual_parameter_list",
"actual_parameter_list","@65","actual_parameter","@66","actual_parameter"
};
#endif

static const short yyr1[] = {     0,
    82,    84,    83,    85,    85,    87,    88,    89,    86,    -1,
    90,    90,    91,    92,    92,    93,    93,    94,    94,    95,
    96,    97,    95,    98,    98,    99,   100,    99,   101,   102,
   103,   101,   104,   105,   106,   105,   108,   107,   109,   107,
   110,   111,   112,   111,   113,   114,   114,   115,   115,   116,
   116,   117,   117,   119,   118,    -1,    -1,    -1,   120,   120,
   120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
   120,   120,   121,   121,   121,   121,   121,   121,   121,   122,
   122,   123,   123,   125,   124,   126,   126,   127,   127,   128,
   129,   130,   130,   131,   131,   131,   132,   134,   133,   135,
   136,   137,   136,   138,   138,   139,   140,   141,   142,   143,
   142,   144,   144,   145,   146,   145,   147,   148,   148,   149,
   150,   151,   152,   151,   153,   154,   155,   153,   156,   157,
   157,   158,   158,   159,   160,   161,   160,   162,   163,   165,
   164,   166,   166,   168,   167,   167,   169,   169,   170,   171,
   171,   171,   171,   173,   172,   174,   172,   175,   172,   176,
   172,   177,   172,   178,   178,   180,   179,   181,   182,   181,
   183,   184,   184,   186,   185,   187,   188,   187,   189,   190,
   189,   191,   192,   191,   193,   193,   193,   194,   194,   196,
   197,   195,   198,   199,   198,   201,   202,   200,   203,   203,
   204,   205,   205,   207,   206,   208,   208,   210,   209,   209,
   211,   211,   211,   213,   214,   212,   216,   217,   215,   219,
   220,   221,   218,   222,   223,   224,   224,   226,   227,   225,
   228,   229,   230,   230,   230,   231,   232,   233,   234,   234,
   236,   235,   237,   238,   239,   240,   241,   240,   242,   243,
   242,   244,   245,   245,   245,   245,   245,   245,   246,   247,
   246,   246,   248,   246,   249,   246,   250,   250,   251,   252,
   251,   253,   251,   254,   251,   255,   255,   255,   256,   256,
   256,   256,   256,   256,   257,   256,   258,   256,   259,   256,
   260,   260,   261,   262,   261,   264,   263
};

static const short yyr2[] = {     0,
     4,     0,     4,     0,     3,     0,     0,     0,     9,     5,
     1,     3,     1,     0,     1,     1,     2,     1,     1,     4,
     0,     0,    12,     2,     5,     0,     0,     4,     4,     0,
     0,    12,     3,     1,     0,     4,     0,     2,     0,     3,
     3,     1,     0,     4,     1,     0,     3,     1,     3,     0,
     2,     1,     2,     0,     5,     0,     1,     1,     1,     2,
     2,     1,     2,     2,     1,     2,     2,     1,     2,     2,
     1,     1,     1,     2,     2,     1,     2,     2,     1,     0,
     2,     1,     2,     0,     5,     1,     1,     1,     1,     1,
     3,     1,     2,     1,     1,     1,     3,     0,     7,     1,
     1,     0,     4,     3,     1,     3,     2,     1,     1,     0,
     4,     0,     3,     1,     0,     4,     1,     0,     4,     1,
     1,     1,     0,     4,     0,     0,     0,     7,     2,     0,
     2,     1,     2,     4,     1,     0,     4,     1,     1,     0,
     4,     1,     3,     0,     3,     2,     0,     1,     2,     0,
     1,     1,     1,     0,     3,     0,     3,     0,     3,     0,
     3,     0,     3,     0,     1,     0,     4,     1,     0,     4,
     1,     0,     1,     0,     4,     1,     0,     4,     1,     0,
     4,     1,     0,     4,     1,     1,     1,     1,     1,     0,
     0,     7,     0,     0,     3,     0,     0,     8,     0,     1,
     1,     1,     3,     0,     4,     1,     3,     0,     2,     1,
     1,     1,     1,     0,     0,     6,     0,     0,     6,     0,
     0,     0,    11,     1,     1,     1,     1,     0,     0,     5,
     2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
     0,     5,     1,     3,     1,     1,     0,     4,     1,     0,
     4,     1,     1,     1,     1,     1,     1,     1,     1,     0,
     3,     2,     0,     4,     0,     4,     1,     1,     1,     0,
     4,     0,     4,     0,     4,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     0,     5,     0,     4,     0,     3,
     0,     3,     1,     0,     4,     0,     2
};

static const short yydefact[] = {     0,
     0,     0,     2,     6,     4,     0,    46,     0,     3,     1,
     0,    50,    13,     0,    11,    48,     0,     0,    80,     5,
     0,    47,     0,     0,    51,    52,     0,   130,    12,    49,
    54,    53,     0,    81,    82,     0,     7,     0,    84,    83,
   138,   131,   132,     0,   135,    14,    71,    72,    65,    59,
    62,    68,     0,     0,     0,     0,   133,   136,     0,     0,
     0,     8,    15,    16,    19,     0,    18,     0,    66,    60,
    63,    69,    67,    61,    70,    55,     0,     0,     0,   112,
    79,    73,    86,     0,     0,     0,     0,    87,    88,    90,
    89,    92,    96,    94,    95,     0,     0,    24,    26,     0,
    17,    21,    30,     0,     0,    93,   117,     0,   118,   108,
   109,     0,   114,    74,    77,    75,    78,     0,    85,   137,
   134,    27,     0,    33,   140,     9,   139,     0,    46,     0,
    46,   105,     0,     0,   101,   100,    97,   106,     0,   107,
   110,   115,     0,    76,    91,    37,     0,   147,    20,    50,
    29,    50,     0,   102,     0,   121,     0,   120,   112,     0,
   113,    39,     0,    34,     0,    25,     0,     0,   142,   144,
   148,    80,    80,   104,     0,    98,   126,   111,   116,     0,
    35,    28,    45,    38,     0,    42,   149,   141,   147,   196,
     0,   190,   217,   214,   185,   150,   146,   186,   188,   189,
   187,   212,   211,   213,   130,   130,   103,     0,   119,   122,
   208,    40,    37,    43,     0,   143,     0,     0,     0,   147,
     0,     0,   154,   156,   158,   160,   162,   145,   152,   151,
   153,   228,   235,   233,   237,   234,   239,     0,   240,     0,
     0,     0,    99,   123,   210,     0,   206,     0,    36,     0,
    41,   289,   282,   283,   279,   280,   281,   238,   287,     0,
   260,     0,   284,   201,   249,   259,   269,   220,   252,     0,
     0,     0,   231,     0,   164,     0,   172,   291,   236,     0,
   241,     0,    22,    31,   126,   208,     0,   209,    44,     0,
   285,     0,   262,     0,   197,   258,   256,   255,   257,   253,
   254,   250,   265,   268,   267,   263,   274,   277,   278,   270,
   276,   272,     0,   191,   218,   215,   166,   155,   157,   165,
   174,   159,   161,   173,   296,   163,   232,   229,     0,   244,
   147,   147,   124,   207,   127,   290,   296,     0,   261,   208,
     0,     0,     0,     0,     0,     0,     0,   224,   147,     0,
   147,     0,     0,     0,   293,     0,     0,     0,   246,     0,
     0,   112,     0,   288,   199,   202,     0,   251,   266,   264,
   275,   271,   273,   227,   226,   221,   193,   219,   216,   238,
     0,   168,   171,     0,   176,   179,   292,   294,   297,   230,
   247,   242,     0,     0,   118,     0,   286,   208,     0,   204,
     0,   194,   192,   167,   169,   175,   177,   180,   296,     0,
    23,    32,   129,   128,   203,   198,   147,     0,   225,   147,
     0,     0,     0,   295,   248,   205,   222,   195,   170,   178,
   181,   182,   147,   183,   223,     0,   184,     0,     0,     0
};

static const short yydefgoto[] = {   438,
     2,     5,     9,     6,     7,    46,   100,    14,    15,    62,
    63,    64,    65,   129,   331,    66,   123,   146,    67,   131,
   332,    68,   163,   213,   164,   165,   180,   184,   185,   250,
   186,    12,    17,    19,    25,    26,    38,    55,    86,    28,
    34,    35,    56,   136,    88,    89,    90,    91,    92,    93,
    94,   208,   137,   134,   175,   135,    95,   108,   109,   110,
   159,   111,   112,   160,   113,   140,   157,   158,   209,   285,
   210,   211,   362,   396,    37,    42,    43,    44,    96,    45,
   126,   127,   148,   168,   169,   196,   170,   171,   228,   229,
   274,   275,   276,   277,   278,   319,   318,   352,   381,   421,
   382,   323,   322,   353,   384,   422,   385,   423,   431,   436,
   197,   198,   199,   219,   349,   403,   420,   200,   217,   340,
   399,   262,   365,   366,   417,   367,   247,   248,   201,   202,
   221,   351,   203,   220,   350,   204,   313,   401,   433,   347,
   418,   376,   230,   280,   357,   231,   328,   263,   233,   234,
   235,   236,   237,   329,   238,   239,   240,   358,   410,   386,
   341,   270,   302,   265,   294,   343,   342,   306,   266,   345,
   346,   344,   312,   267,   337,   292,   290,   326,   354,   409,
   355,   356
};

static const short yypact[] = {   -12,
   -34,    -5,-32768,-32768,     1,    22,    53,    41,-32768,-32768,
    92,   109,-32768,   -18,-32768,-32768,    -7,    91,   125,-32768,
    41,-32768,   101,    94,    91,-32768,   108,   165,-32768,-32768,
-32768,-32768,   133,   108,-32768,   142,-32768,   120,-32768,-32768,
-32768,   142,-32768,    26,-32768,    14,-32768,-32768,-32768,-32768,
-32768,-32768,    58,    46,   145,     9,-32768,-32768,     9,   149,
   150,-32768,    14,-32768,-32768,   151,-32768,   152,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   144,   196,    20,   157,
-32768,-32768,   185,   -33,    16,   190,   170,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   142,   171,    -4,   172,   234,
-32768,   228,   230,   168,     9,-32768,-32768,   236,   243,   184,
-32768,    54,-32768,-32768,-32768,-32768,-32768,   173,-32768,-32768,
-32768,-32768,   180,-32768,-32768,-32768,-32768,   187,    53,   188,
    53,   185,   210,   -23,-32768,-32768,-32768,-32768,   191,-32768,
-32768,-32768,     9,-32768,-32768,   219,   192,   197,-32768,   109,
-32768,   109,   173,-32768,   237,-32768,   238,-32768,   157,   157,
-32768,-32768,    60,-32768,   193,-32768,   189,     0,-32768,   186,
-32768,   125,   125,-32768,   168,-32768,    -1,-32768,-32768,   193,
-32768,-32768,-32768,-32768,    69,-32768,-32768,-32768,   197,-32768,
   198,-32768,-32768,-32768,-32768,    88,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   165,   165,-32768,     9,   199,-32768,
   223,-32768,   219,-32768,   201,-32768,    39,   221,    39,   197,
    39,   206,-32768,-32768,-32768,-32768,   -27,-32768,-32768,-32768,
-32768,   -41,-32768,-32768,-32768,-32768,-32768,   194,-32768,   203,
   266,   267,-32768,-32768,-32768,    73,-32768,   120,-32768,   193,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   205,-32768,    87,
-32768,   250,   -41,   134,     2,     7,-32768,-32768,   134,   244,
   -21,    12,-32768,   207,   207,   209,   209,   211,-32768,   232,
-32768,   215,-32768,-32768,    -1,   223,   213,-32768,-32768,    87,
-32768,    39,     7,    87,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    39,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    39,-32768,
   197,   197,-32768,-32768,-32768,-32768,-32768,    89,     7,   223,
    39,    87,    87,    87,    87,    87,    10,   134,   197,    39,
   197,   217,    39,    61,-32768,    39,    39,   -16,   134,     6,
    13,   157,   100,-32768,   218,-32768,   117,     2,     7,     7,
-32768,-32768,-32768,-32768,-32768,-32768,   272,   134,-32768,-32768,
   127,-32768,   -41,   129,-32768,    93,-32768,-32768,   134,   134,
-32768,-32768,   220,   222,   243,   216,-32768,     5,   275,-32768,
    39,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    39,
-32768,-32768,-32768,-32768,-32768,-32768,   197,   280,   134,   197,
   217,    39,    39,-32768,   134,-32768,-32768,-32768,-32768,-32768,
-32768,   131,   197,-32768,-32768,    39,   134,   290,   291,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   271,-32768,
-32768,   231,-32768,-32768,-32768,-32768,   200,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    80,-32768,-32768,   115,-32768,-32768,
    47,   -87,-32768,   -35,-32768,   273,-32768,    48,   -95,    17,
-32768,   268,-32768,   -51,-32768,-32768,-32768,-32768,   224,-32768,
-32768,-32768,    96,-32768,-32768,   126,-32768,-32768,   -62,-32768,
-32768,   146,-32768,-32768,   147,   -89,-32768,-32768,-32768,-32768,
    23,-32768,-32768,-32768,    19,-32768,   269,-32768,-32768,   214,
-32768,   139,-32768,  -213,  -189,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    37,-32768,-32768,-32768,
  -108,-32768,    38,-32768,-32768,-32768,  -106,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   -84,-32768,   106,    32,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -195,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -215,
-32768,-32768,-32768,   -22,-32768,-32768,-32768,-32768,  -257,-32768,
-32768,-32768,-32768,  -251,-32768,-32768,-32768,-32768,   -17,-32768,
   -88,-32768
};


#define	YYLAST		321


static const short yytable[] = {   216,
   232,   264,   293,   269,    87,   272,   271,    97,   133,   307,
  -125,   188,    77,   315,   308,     1,  -200,   393,  -238,   374,
   316,    78,   145,    77,   394,  -245,   303,   309,   114,    60,
     3,   115,    78,  -243,    79,   279,   339,    80,   336,  -238,
    61,   150,   375,   152,   189,   245,   154,  -238,    80,  -238,
    20,    21,   155,   391,   296,   297,   298,   174,    22,   392,
     4,   252,    23,   122,  -125,   189,   -26,  -125,     8,    81,
    82,   189,    11,    83,   304,   305,   338,   116,   189,   133,
   117,    84,    85,   299,   369,   370,   310,   311,    10,   300,
   301,   161,   371,   372,   373,    58,    59,   348,   253,   254,
   255,   256,   257,   258,   222,    13,   259,    73,    74,   252,
    75,   260,   261,   359,   172,    18,   173,   360,   361,    69,
    70,    71,    72,   142,   143,   181,   223,   224,   182,   387,
   388,   296,   297,   298,   378,   296,   297,   298,   214,   215,
   389,   390,   286,   287,   225,   226,   253,   254,   255,   256,
   257,   258,   227,    16,   259,    24,   383,   364,    27,   377,
   299,   379,    30,   408,   299,    31,   300,   301,   397,   388,
   300,   301,    33,   296,   297,   298,   296,   297,   298,    47,
    48,    49,    50,    51,    52,   419,   286,   400,   205,   206,
   125,   190,    53,    54,   425,   404,   405,   406,   407,   191,
    36,   434,   299,   192,    39,   299,    41,   432,   300,   301,
    76,   300,   301,    98,    99,   193,   102,   103,   104,   105,
   437,   107,   194,   241,   242,   383,   -76,   426,    81,    82,
   428,   118,   132,    81,    82,   119,   121,   144,   125,   122,
    84,    85,   128,   435,   130,    84,    85,   138,   139,   141,
   147,   153,   149,   151,   162,   156,   166,   183,   167,   187,
   176,   177,   218,   245,   244,   251,   268,   273,   281,   282,
   283,   284,   291,   295,   317,   314,   321,   327,   325,   330,
   335,   380,   402,   398,   414,   411,   416,   412,   427,   439,
   440,    29,   249,   101,   212,   288,   289,    32,   124,   395,
   207,    40,   106,   243,   178,   413,   179,   333,   195,   120,
    57,   320,   429,   415,   324,   430,   246,   334,   368,   363,
   424
};

static const short yycheck[] = {   189,
   196,   217,   260,   219,    56,   221,   220,    59,   104,     3,
    12,    12,     4,    35,     8,    28,    12,    12,    46,    10,
     9,    13,   118,     4,    12,    67,    25,    21,    62,    16,
    65,    65,    13,    75,    26,    77,   294,    29,   290,    67,
    27,   129,    33,   131,    66,    41,    70,    75,    29,    77,
    69,    70,    76,    70,    43,    44,    45,   153,    66,    76,
    66,    23,    70,    68,    66,    66,    71,    69,    68,    61,
    62,    66,    20,    65,    73,    74,   292,    62,    66,   175,
    65,    73,    74,    72,   342,   343,    80,    81,    67,    78,
    79,   143,   344,   345,   346,    70,    71,   313,    60,    61,
    62,    63,    64,    65,    17,    65,    68,    62,    63,    23,
    65,    73,    74,   329,   150,     7,   152,   331,   332,    62,
    63,    64,    65,    70,    71,    66,    39,    40,    69,    69,
    70,    43,    44,    45,   350,    43,    44,    45,    70,    71,
   356,   357,    70,    71,    57,    58,    60,    61,    62,    63,
    64,    65,    65,    62,    68,    65,   352,    69,    34,   349,
    72,   351,    62,    71,    72,    72,    78,    79,    69,    70,
    78,    79,    65,    43,    44,    45,    43,    44,    45,    60,
    61,    62,    63,    64,    65,   401,    70,    71,   172,   173,
     5,     6,    73,    74,   410,    69,    70,    69,    70,    14,
    36,    71,    72,    18,    72,    72,    65,   423,    78,    79,
    66,    78,    79,    65,    65,    30,    66,    66,    75,    24,
   436,    65,    37,   205,   206,   421,    42,   417,    61,    62,
   420,    42,    65,    61,    62,    66,    66,    65,     5,    68,
    73,    74,    15,   433,    15,    73,    74,    12,     6,    66,
    71,    42,    66,    66,    36,    65,    65,    65,    62,    71,
    24,    24,    65,    41,    66,    65,    46,    62,    75,    67,
     5,     5,    68,    24,    68,    32,    68,    46,    68,    65,
    68,    65,    11,    66,    69,    66,    12,    66,     9,     0,
     0,    21,   213,    63,   180,   248,   250,    25,    99,   362,
   175,    34,    79,   208,   159,   395,   160,   285,   170,    96,
    42,   275,   421,   398,   277,   422,   211,   286,   341,   337,
   409
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (_X86_)
#include <malloc.h>
#define alloca _alloca
#else
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca (unsigned int);
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */
#endif

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 133 "gram.y"
{
		  prog_symbol = yyvsp[0].sym;
		  open_name_file ();
                  open_header_file ();
		;
    break;}
case 6:
#line 147 "gram.y"
{
		  redir_file (H_FILE_NUM);
		;
    break;}
case 7:
#line 154 "gram.y"
{
		  redir_file (C_FILE_NUM);
		;
    break;}
case 8:
#line 158 "gram.y"
{
                  if (! one_c_file)
		    begin_new_c_file (prog_symbol->s_repr, 1);
		  routine_handle = 0;
		  forget_fast_vars ();
		  out_s ("\nvoid main (int argc, char * * argv)\n\n");
		;
    break;}
case 9:
#line 166 "gram.y"
{
		  if (n_fast_vars)
		    declare_fast_var_macro (routine_handle);
		  close_file (C_FILE_NUM);
		  close_name_file ();
		;
    break;}
case 13:
#line 192 "gram.y"
{
		;
    break;}
case 18:
#line 208 "gram.y"
{
		  /* putchar ('.'); */
		;
    break;}
case 19:
#line 212 "gram.y"
{
		  /* putchar ('.'); */
		;
    break;}
case 20:
#line 219 "gram.y"
{
		;
    break;}
case 21:
#line 222 "gram.y"
{
		  routine_handle++;
		  begin_routine (yyvsp[-1].type_ptr, routine_handle);
		;
    break;}
case 22:
#line 234 "gram.y"
{
		  out_form ("\n%s _c4p_result;\n\n",
			    ((prototype_node *)
			     yyvsp[-7].type_ptr)->result_type->s_repr);
		  out_form ("_C4P_PROC_ENTRY (%u);\n", routine_handle);
		;
    break;}
case 23:
#line 241 "gram.y"
{
		  out_s ("\n");
		  out_form ("_C4P_PROC_EXIT (%u);\n", routine_handle);
		  out_s ("return (_c4p_result);\n");
		  end_routine (routine_handle);
		;
    break;}
case 24:
#line 251 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != FUNCTION_IDENTIFIER)
		    c4p_error ("`%s' is not a function name", yyvsp[0].sym->s_repr);
		  yyval.type_ptr = yyvsp[0].sym->s_type_ptr;
		;
    break;}
case 25:
#line 258 "gram.y"
{
		  if (yyvsp[-3].sym->s_kind != UNDEFINED_IDENTIFIER)
		    c4p_error ("`%s' already defined", yyvsp[-3].sym->s_repr);
		  if (yyvsp[0].sym->s_kind != TYPE_IDENTIFIER)
		    c4p_error ("`%s' is not a type identifier", yyvsp[0].sym->s_repr);
		  yyval.type_ptr = new_type_node (PROTOTYPE_NODE, yyvsp[-3].sym, yyvsp[-2].type_ptr, yyvsp[0].sym);
		  yyvsp[-3].sym->s_kind = FUNCTION_IDENTIFIER;
		  yyvsp[-3].sym->s_type = PROTOTYPE_NODE;
		  yyvsp[-3].sym->s_type_ptr = yyval.type_ptr;
		;
    break;}
case 26:
#line 272 "gram.y"
{
		  yyval.type_ptr = 0;
		;
    break;}
case 27:
#line 276 "gram.y"
{
		  mark_symbol_table ();
		;
    break;}
case 28:
#line 280 "gram.y"
{
		  unmark_symbol_table ();
		  yyval.type_ptr = yyvsp[-1].type_ptr;
		;
    break;}
case 29:
#line 288 "gram.y"
{
		;
    break;}
case 30:
#line 291 "gram.y"
{
		  routine_handle++;
		  begin_routine (yyvsp[-1].type_ptr, routine_handle);
		;
    break;}
case 31:
#line 300 "gram.y"
{
		  out_form ("_C4P_PROC_ENTRY (%u);\n", routine_handle);
		;
    break;}
case 32:
#line 304 "gram.y"
{
		  out_form ("_C4P_PROC_EXIT (%u);\n", routine_handle);
		  end_routine (routine_handle);
		;
    break;}
case 33:
#line 312 "gram.y"
{
		  if (yyvsp[-1].sym->s_kind == PROCEDURE_IDENTIFIER)
		    {
		      if (yyvsp[0].type_ptr != 0)
		        c4p_error ("`%s' already declared", yyvsp[-1].sym->s_repr);
		      yyval.type_ptr = yyvsp[-1].sym->s_type_ptr;
		    }
		  else
		    {
		      if (yyvsp[-1].sym->s_kind != UNDEFINED_IDENTIFIER)
		        c4p_error ("`%s' already declared", yyvsp[-1].sym->s_repr);
		     yyval.type_ptr = new_type_node (PROTOTYPE_NODE, yyvsp[-1].sym, yyvsp[0].type_ptr, 0);
		     yyvsp[-1].sym->s_kind = PROCEDURE_IDENTIFIER;
		     yyvsp[-1].sym->s_type = PROTOTYPE_NODE;
		     yyvsp[-1].sym->s_type_ptr = yyval.type_ptr;
		    }
		;
    break;}
case 35:
#line 334 "gram.y"
{
		  yyval.type_ptr = last_parameter;
		;
    break;}
case 36:
#line 338 "gram.y"
{
		  ((parameter_node *) yyvsp[-1].type_ptr)->next = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr;
		;
    break;}
case 37:
#line 345 "gram.y"
{
		  by_reference = 0;
		;
    break;}
case 38:
#line 349 "gram.y"
{
		  yyval.type_ptr = yyvsp[0].type_ptr;
		;
    break;}
case 39:
#line 353 "gram.y"
{
		  by_reference = 1;
		;
    break;}
case 40:
#line 357 "gram.y"
{
		  yyval.type_ptr = yyvsp[0].type_ptr;
		;
    break;}
case 41:
#line 368 "gram.y"
{
		  parameter_node * par = yyvsp[-2].type_ptr;

		  if (yyvsp[0].sym->s_kind != TYPE_IDENTIFIER)
		    c4p_error ("`%s' is not a type identifier", yyvsp[0].sym->s_repr);
		  while (par != 0)
		    {
		      if (yyvsp[0].sym->s_type != ARRAY_NODE)
		        par->by_reference = by_reference;
		      else
		        par->by_reference = 0;
		      par->type_symbol = yyvsp[0].sym;
		      par = par->next;
		    }
      		  yyval.type_ptr = yyvsp[-2].type_ptr;
		;
    break;}
case 43:
#line 389 "gram.y"
{
		  yyval.type_ptr = last_parameter;
		;
    break;}
case 44:
#line 393 "gram.y"
{
		  ((parameter_node *) yyvsp[-1].type_ptr)->next = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr;
		;
    break;}
case 45:
#line 401 "gram.y"
{
		  yyval.type_ptr = new_type_node (PARAMETER_NODE, yyvsp[0].sym->s_repr);
		  last_parameter = yyval.type_ptr;
		;
    break;}
case 48:
#line 415 "gram.y"
{
		;
    break;}
case 54:
#line 433 "gram.y"
{
		  out_form ("#define %s ", yyvsp[-1].sym->s_repr);
		;
    break;}
case 55:
#line 437 "gram.y"
{
		  define_symbol (yyvsp[-4].sym, CONSTANT_IDENTIFIER, block_level,
				 last_type, 0, &last_value);
		  out_s ("\n");
		;
    break;}
case 59:
#line 452 "gram.y"
{
		  last_value.fvalue = yyvsp[0].fvalue;
		  last_type = REAL_TYPE;
		  out_form ("%lf", (double) last_value.fvalue);
		;
    break;}
case 60:
#line 458 "gram.y"
{
		  last_value.fvalue = yyvsp[0].fvalue;
		  last_type = REAL_TYPE;
		  out_form ("%lf", (double) last_value.fvalue);
		;
    break;}
case 61:
#line 464 "gram.y"
{
		  last_value.fvalue = - yyvsp[0].fvalue;
		  last_type = REAL_TYPE;
		  out_form ("%lf", (double) last_value.fvalue);
		;
    break;}
case 62:
#line 470 "gram.y"
{
		  last_value.fvalue = yyvsp[0].fvalue;
		  last_type = LONG_REAL_TYPE;
		  out_form ("%lf", (double) last_value.fvalue);
		;
    break;}
case 63:
#line 476 "gram.y"
{
		  last_value.fvalue = yyvsp[0].fvalue;
		  last_type = LONG_REAL_TYPE;
		  out_form ("%lf", (double) last_value.fvalue);
		;
    break;}
case 64:
#line 482 "gram.y"
{
		  last_value.fvalue = - yyvsp[0].fvalue;
		  last_type = LONG_REAL_TYPE;
		  out_form ("%lf", (double) last_value.fvalue);
		;
    break;}
case 65:
#line 489 "gram.y"
{
		  last_value.ivalue = yyvsp[0].value;
		  last_type = INTEGER_TYPE;
		  out_form ("%ldl", last_value.ivalue);
		;
    break;}
case 66:
#line 495 "gram.y"
{
		  last_value.ivalue = yyvsp[0].value;
		  last_type = INTEGER_TYPE;
		  out_form ("%ldl", last_value.ivalue);
		;
    break;}
case 67:
#line 501 "gram.y"
{
		  last_value.ivalue = - yyvsp[0].value;
		  last_type = INTEGER_TYPE;
		  out_form ("%ldl", last_value.ivalue);
		;
    break;}
case 68:
#line 507 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != CONSTANT_IDENTIFIER)
		    c4p_error ("`%s' is not a constant identifier",
			       yyvsp[0].sym->s_repr);
		  last_value = yyvsp[0].sym->s_value;
		  last_type = yyvsp[0].sym->s_type;
		  out_form ("%s", yyvsp[0].sym->s_repr);
		;
    break;}
case 69:
#line 516 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != CONSTANT_IDENTIFIER)
		    c4p_error ("`%s' is not a constant identifier",
			       yyvsp[0].sym->s_repr);
		  last_value = yyvsp[0].sym->s_value;
		  last_type = yyvsp[0].sym->s_type;
		  out_form ("%s", yyvsp[0].sym->s_repr);
		;
    break;}
case 70:
#line 525 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != CONSTANT_IDENTIFIER)
		    c4p_error ("`%s' is not a constant identifier",
			       yyvsp[0].sym->s_repr);

		  /* das ist nicht richtig: */
		  last_value.ivalue = - yyvsp[0].sym->s_value.ivalue;

		  last_type = yyvsp[0].sym->s_type;
		  out_form ("(-%s)", yyvsp[0].sym->s_repr);
		;
    break;}
case 71:
#line 537 "gram.y"
{
		  last_value.ivalue = yyvsp[0].value;
		  last_type = STRING_TYPE;
		  out_s ("\"");
		  translate_string (get_string ((STRING_PTR) yyvsp[0].value));
		  out_s ("\"");
		;
    break;}
case 72:
#line 545 "gram.y"
{
		  last_value.ivalue = yyvsp[0].value;
		  last_type = CHARACTER_TYPE;
		  out_s ("\'");
		  translate_char ((int) yyvsp[0].value);
		  out_s ("\'");
		;
    break;}
case 74:
#line 557 "gram.y"
{
		  yyval.value = yyvsp[0].value;
		;
    break;}
case 75:
#line 561 "gram.y"
{
		  yyval.value = - yyvsp[0].value;
		;
    break;}
case 76:
#line 565 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != CONSTANT_IDENTIFIER)
		    c4p_error ("`%s' is not a constant identifier",
			       yyvsp[0].sym->s_repr);
		  yyval.value = yyvsp[0].sym->s_value.ivalue;
		;
    break;}
case 77:
#line 572 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != CONSTANT_IDENTIFIER)
		    c4p_error ("`%s' is not a constant identifier",
			       yyvsp[0].sym->s_repr);
		  yyval.value = yyvsp[0].sym->s_value.ivalue;
		;
    break;}
case 78:
#line 579 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != CONSTANT_IDENTIFIER)
		    c4p_error ("`%s' is not a constant identifier",
			       yyvsp[0].sym->s_repr);
		  yyval.value = - yyvsp[0].sym->s_value.ivalue;
		;
    break;}
case 84:
#line 600 "gram.y"
{
		  out_s ("typedef ");
		;
    break;}
case 85:
#line 604 "gram.y"
{
		  define_type (yyvsp[-4].sym, block_level, last_type, yyvsp[-1].type_ptr);
		  out_s (";\n");
		;
    break;}
case 86:
#line 612 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != TYPE_IDENTIFIER)
		    c4p_error ("`%s' is not a type identifier", yyvsp[0].sym->s_repr);
		  last_type = NAMED_TYPE_NODE;
		  yyval.type_ptr = new_type_node (NAMED_TYPE_NODE, yyvsp[0].sym);
		;
    break;}
case 91:
#line 638 "gram.y"
{
		  last_type = SUBRANGE_NODE;
		  yyval.type_ptr = new_type_node (SUBRANGE_NODE, yyvsp[-2].value, yyvsp[0].value);
		;
    break;}
case 93:
#line 647 "gram.y"
{
		  yyval.type_ptr = yyvsp[0].type_ptr;
		;
    break;}
case 97:
#line 663 "gram.y"
{
		  yyval.type_ptr = new_type_node (FILE_NODE, last_type, yyvsp[0].type_ptr);
		  last_type = FILE_NODE;
		;
    break;}
case 98:
#line 671 "gram.y"
{
		  yyval.type_ptr = last_array_node;
		;
    break;}
case 99:
#line 675 "gram.y"
{
		  ((array_node *) yyvsp[-1].type_ptr)->component_type = last_type;
		  ((array_node *) yyvsp[-1].type_ptr)->component_type_ptr = yyvsp[0].type_ptr;
		  last_type = ARRAY_NODE;
		  yyval.type_ptr = yyvsp[-4].type_ptr;
		;
    break;}
case 102:
#line 690 "gram.y"
{
		  yyval.type_ptr = last_array_node;
		;
    break;}
case 103:
#line 694 "gram.y"
{
		  ((array_node *) yyvsp[-1].type_ptr)->component_type = ARRAY_NODE;
		  ((array_node *) yyvsp[-1].type_ptr)->component_type_ptr = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr;
		;
    break;}
case 104:
#line 703 "gram.y"
{
		  last_array_node = new_type_node (ARRAY_NODE, yyvsp[-2].value, yyvsp[0].value);
		  yyval.type_ptr = last_array_node;
		;
    break;}
case 105:
#line 708 "gram.y"
{
		  long lbound;
		  long ubound;

		  if (yyvsp[0].sym->s_kind != TYPE_IDENTIFIER)
		    c4p_error ("`%s' is not a type identifier", yyvsp[0].sym->s_repr);
		  if (yyvsp[0].sym->s_type == CHARACTER_TYPE)
		    {
		      lbound = -128;
		      ubound = 127;
		    }
		  else
		    if (yyvsp[0].sym->s_type == BOOLEAN_TYPE)
		      {
			lbound = 0;
			ubound = 1;
		      }
		    else
		      if (yyvsp[0].sym->s_type != SUBRANGE_NODE)
			c4p_error ("`%s' is not a subrange type identifier",
				   yyvsp[0].sym->s_repr);
		      else
			{
			  lbound =
			    ((subrange_node *) yyvsp[0].sym->s_type_ptr)->lower_bound;
			  ubound =
			    ((subrange_node *) yyvsp[0].sym->s_type_ptr)->upper_bound;
			}
		  last_array_node = new_type_node (ARRAY_NODE, lbound, ubound);
		  yyval.type_ptr = last_array_node;
		;
    break;}
case 106:
#line 743 "gram.y"
{
		  last_type = RECORD_NODE;
		  yyval.type_ptr = new_type_node (RECORD_NODE, yyvsp[-1].type_ptr);
		;
    break;}
case 107:
#line 751 "gram.y"
{
		  yyval.type_ptr = new_type_node (FIELD_LIST_NODE, yyvsp[-1].type_ptr, yyvsp[0].type_ptr);
		;
    break;}
case 110:
#line 763 "gram.y"
{
		  yyval.type_ptr = last_record_section;
		;
    break;}
case 111:
#line 767 "gram.y"
{
		  ((record_section_node *) yyvsp[-1].type_ptr)->next = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr;
		;
    break;}
case 112:
#line 775 "gram.y"
{
		  yyval.type_ptr = 0;
		;
    break;}
case 113:
#line 779 "gram.y"
{
		  yyval.type_ptr = new_type_node (RECORD_SECTION_NODE, yyvsp[-2].type_ptr, last_type, yyvsp[0].type_ptr);
		  last_record_section = yyval.type_ptr;
		;
    break;}
case 115:
#line 788 "gram.y"
{
		  yyval.type_ptr = last_declarator;
		;
    break;}
case 116:
#line 792 "gram.y"
{
		  ((declarator_node *) yyvsp[-1].type_ptr)->next = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr;
		;
    break;}
case 117:
#line 800 "gram.y"
{
		  yyval.type_ptr = new_type_node (DECLARATOR_NODE, yyvsp[0].sym);
		  last_declarator = yyval.type_ptr;
		;
    break;}
case 118:
#line 808 "gram.y"
{
		  yyval.type_ptr = 0;
		;
    break;}
case 119:
#line 812 "gram.y"
{
		  yyval.type_ptr = new_type_node (VARIANT_NODE, yyvsp[0].type_ptr);
		;
    break;}
case 121:
#line 826 "gram.y"
{
		;
    break;}
case 123:
#line 833 "gram.y"
{
		  yyval.type_ptr = last_variant;
		;
    break;}
case 124:
#line 837 "gram.y"
{
		  ((variant_field_list_node *) yyvsp[-1].type_ptr)->next = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr
		;
    break;}
case 125:
#line 845 "gram.y"
{
		  yyval.type_ptr = last_variant = 0;
		;
    break;}
case 126:
#line 849 "gram.y"
{
		  out_stop ();
		;
    break;}
case 127:
#line 853 "gram.y"
{
		  out_resume ();
		;
    break;}
case 128:
#line 857 "gram.y"
{
		  yyval.type_ptr = yyvsp[-1].type_ptr;
		  last_variant = yyval.type_ptr;
		;
    break;}
case 129:
#line 865 "gram.y"
{
		  yyval.type_ptr = new_type_node (VARIANT_FIELD_LIST_NODE, yyvsp[-1].type_ptr, yyvsp[0].type_ptr);
		;
    break;}
case 134:
#line 882 "gram.y"
{
		  if (block_level == 0)
		    out_s ("EXTERN ");
	          declare_var_list (yyvsp[-3].type_ptr, VARIABLE_IDENTIFIER, block_level,
				    last_type, yyvsp[-1].type_ptr);
		  out_s (";\n");
		;
    break;}
case 136:
#line 894 "gram.y"
{
		  yyval.type_ptr = last_declarator;
		;
    break;}
case 137:
#line 898 "gram.y"
{
		  ((declarator_node *) yyvsp[-1].type_ptr)->next = yyvsp[0].type_ptr;
		  yyval.type_ptr = yyvsp[-3].type_ptr;
		;
    break;}
case 138:
#line 906 "gram.y"
{
		  yyval.type_ptr = new_type_node (DECLARATOR_NODE, yyvsp[0].sym);
		  last_declarator = yyval.type_ptr;
		;
    break;}
case 140:
#line 918 "gram.y"
{
		  out_s ("{\n");
		  curly_brace_level++;
		  if (routine_handle == 0 && curly_brace_level == 1)
		    {
		      if (n_fast_vars)
			out_s ("_C4P_FAST_VARS_0\n");
		      out_s ("if (_c4p_startup (argc, argv) != 0)\n");
		      out_s ("   exit (EXIT_FAILURE);\n");
		    }
		;
    break;}
case 141:
#line 930 "gram.y"
{
		  if (routine_handle == 0 && curly_brace_level == 1)
		    {
		      out_s ("exit (EXIT_SUCCESS);\n");
		    }
		  curly_brace_level--;

		  out_s ("}\n");
		;
    break;}
case 144:
#line 948 "gram.y"
{
		  buf_mark2 = NO_MARK;
		;
    break;}
case 149:
#line 962 "gram.y"
{
		  out_form ("\n_c4p_L%ld:\n", yyvsp[-1].value);
		;
    break;}
case 150:
#line 969 "gram.y"
{
		  out_s(";\n");
		;
    break;}
case 154:
#line 979 "gram.y"
{
		  to_eoln = 0;
		;
    break;}
case 156:
#line 984 "gram.y"
{
		  to_eoln = 1;
		;
    break;}
case 158:
#line 989 "gram.y"
{
		  to_eoln = 0;
		;
    break;}
case 160:
#line 994 "gram.y"
{
		  to_eoln = 1;
		;
    break;}
case 162:
#line 999 "gram.y"
{
		  if (yyvsp[0].sym->s_kind != PROCEDURE_IDENTIFIER)
		    c4p_error ("`%s' is not a procedure identifier",
			       yyvsp[0].sym->s_repr);
		  out_form ("%s (", yyvsp[0].sym->s_repr);
		  push_parameter_node (last_parameter);
		  last_parameter =
		    ((prototype_node * ) yyvsp[0].sym->s_type_ptr)->formal_parameter;
		;
    break;}
case 163:
#line 1009 "gram.y"
{
		  pop_parameter_node (last_parameter);
		  out_s (");\n");
		;
    break;}
case 164:
#line 1017 "gram.y"
{
		  out_s ("_c4p_readln ();\n");
		;
    break;}
case 166:
#line 1025 "gram.y"
{
	  	  if (to_eoln)
		    out_s ("_C4P_READLN_BEGIN () ");
		  else
		    out_s ("_C4P_READ_BEGIN () ");
		  out_s ("_c4p_read_");
		  buf_mark = get_buf_mark ();
		  out_s ("_ (");
		  file_specified = 0;
		  strcpy (file_spec, "input");
		;
    break;}
case 167:
#line 1037 "gram.y"
{
	  	  if (to_eoln)
		    out_form (", %s); _C4P_READLN_END (%s)\n",
			      file_spec, file_spec);
		  else
		    out_form (", %s); _C4P_READ_END (%s)\n",
			      file_spec, file_spec);
		;
    break;}
case 169:
#line 1050 "gram.y"
{
		  out_form (", %s); _c4p_read_", file_spec);
		  buf_mark = get_buf_mark ();
		  out_s ("_ (");
	        ;
    break;}
case 171:
#line 1060 "gram.y"
{
		  if (file_specified && file_type != CHARACTER_TYPE)
		    out_buf_over (buf_mark, "v", 1);
		  else
		    switch (last_type)
		      {
		      case FILE_NODE:
			out_buf_over (buf_mark, "f", 1);
      		        file_specified = 1;
			get_buf_text (file_spec, buf_mark + 3, 0);
      		        file_type = ((file_node *) last_type_ptr)->type;
			break;
		      case REAL_TYPE:
		      case LONG_REAL_TYPE:
      		        out_buf_over (buf_mark, "r", 1); break;
		      case INTEGER_TYPE:
      		        out_buf_over (buf_mark, "i", 1); break;
		      case SUBRANGE_NODE:
      		        out_buf_over (buf_mark, "i", 1); break;
		      case CHARACTER_TYPE:
      		        out_buf_over (buf_mark, "c", 1); break;
		      case STRING_TYPE:
      		        out_buf_over (buf_mark, "s", 1); break;
		      default:
	                c4p_error ("internal error: unknown read type");
		      }
		;
    break;}
case 172:
#line 1091 "gram.y"
{
		  out_s ("_c4p_writeln ();\n");
		;
    break;}
case 174:
#line 1099 "gram.y"
{
	  	  if (to_eoln)
		    out_s ("_C4P_WRITELN_BEGIN () ");
		  else
		    out_s ("_C4P_WRITE_BEGIN () ");
		  out_s ("_c4p_write_");
		  buf_mark = get_buf_mark ();
		  out_s ("__ (");
		  file_specified = 0;
		  strcpy (file_spec, "output");
		;
    break;}
case 175:
#line 1111 "gram.y"
{
	  	  if (to_eoln)
		    out_form (", %s); _C4P_WRITELN_END (%s)\n",
			      file_spec, file_spec);
		  else
		    out_form (", %s); _C4P_WRITE_END (%s)\n",
			      file_spec, file_spec);
		;
    break;}
case 177:
#line 1124 "gram.y"
{
		  out_form (", %s); _c4p_write_", file_spec);
		  buf_mark = get_buf_mark ();
		  out_s ("__ (");
	        ;
    break;}
case 179:
#line 1134 "gram.y"
{
		  if (file_specified && file_type != CHARACTER_TYPE)
		    out_buf_over (buf_mark, "v ", 2);
		  else
		    switch (last_type)
		      {
		      case FILE_NODE:
			out_buf_over (buf_mark, "f ", 2);
      		        file_specified = 1;
			get_buf_text (file_spec, buf_mark + 4, 0);
      		        file_type = ((file_node *) last_type_ptr)->type;
			break;
		      case REAL_TYPE:
		      case LONG_REAL_TYPE:
      		        out_buf_over (buf_mark, "r ", 2); break;
		      case INTEGER_TYPE:
      		        out_buf_over (buf_mark, "i ", 2); break;
		      case SUBRANGE_NODE:
      		        out_buf_over (buf_mark, "i ", 2); break;
		      case CHARACTER_TYPE:
      		        out_buf_over (buf_mark, "c ", 2); break;
		      case ARRAY_NODE:
		      case STRING_TYPE:
      		        out_buf_over (buf_mark, "s ", 2); break;
		      default:
	                c4p_error ("internal error: unknown write type: %u",
				   last_type);
		      }
		;
    break;}
case 180:
#line 1164 "gram.y"
{
		  switch (last_type)
		    {
		    case REAL_TYPE:
		    case LONG_REAL_TYPE:
		      out_buf_over (buf_mark, "r1", 2); break;
		    case INTEGER_TYPE:
		      out_buf_over (buf_mark, "i1", 2); break;
		    case SUBRANGE_NODE:
		      out_buf_over (buf_mark, "i1", 2); break;
		    case CHARACTER_TYPE:
		      out_buf_over (buf_mark, "c1", 2); break;
		    case STRING_TYPE:
		      out_buf_over (buf_mark, "s1", 2); break;
		    default:
		      c4p_error ("internal error: unkown write type: %u",
				 last_type);
		    }
		  out_s (", ");
		;
    break;}
case 182:
#line 1189 "gram.y"
{
		;
    break;}
case 183:
#line 1192 "gram.y"
{
		  out_s (", ");
		;
    break;}
case 184:
#line 1196 "gram.y"
{
      		  out_buf_over (buf_mark + 1, "2", 1); break;
      		;
    break;}
case 190:
#line 1218 "gram.y"
{
		  out_s ("if (");
		;
    break;}
case 191:
#line 1222 "gram.y"
{
		  out_s (")\n");
		  extra_indent++;
		;
    break;}
case 193:
#line 1231 "gram.y"
{
		  extra_indent--;
		;
    break;}
case 194:
#line 1235 "gram.y"
{
		  extra_indent--;
		  out_s ("else\n");
		  extra_indent++;
		;
    break;}
case 195:
#line 1241 "gram.y"
{
		  extra_indent--;
		;
    break;}
case 196:
#line 1248 "gram.y"
{
		  out_s ("switch (");
		;
    break;}
case 197:
#line 1252 "gram.y"
{
		  out_s (") {\n");
		  curly_brace_level++;
		;
    break;}
case 198:
#line 1257 "gram.y"
{
		  curly_brace_level--;
		  out_s ("}\n");
		;
    break;}
case 201:
#line 1270 "gram.y"
{
		;
    break;}
case 204:
#line 1281 "gram.y"
{
		  extra_indent++;
		;
    break;}
case 205:
#line 1285 "gram.y"
{
		  out_s ("break;\n");
		  extra_indent--;
		;
    break;}
case 208:
#line 1297 "gram.y"
{
		  out_s ("case ");
		;
    break;}
case 209:
#line 1301 "gram.y"
{
		  out_s (":\n");
		;
    break;}
case 210:
#line 1306 "gram.y"
{
		  out_s ("default:\n");
		;
    break;}
case 214:
#line 1319 "gram.y"
{
		  out_s ("while (");
		;
    break;}
case 215:
#line 1323 "gram.y"
{
		  out_s (")\n");
		  extra_indent++;
		;
    break;}
case 216:
#line 1328 "gram.y"
{
		  extra_indent--;
		;
    break;}
case 217:
#line 1335 "gram.y"
{
		  out_s ("do {\n");
		  curly_brace_level++;
		;
    break;}
case 218:
#line 1340 "gram.y"
{
		  curly_brace_level--;
		  out_s ("} while (! (");
		;
    break;}
case 219:
#line 1345 "gram.y"
{
		  out_s ("));\n");
		;
    break;}
case 220:
#line 1353 "gram.y"
{
		  out_form ("_C4P_FOR_BEGIN (%s, ", yyvsp[-1].sym->s_repr);
		;
    break;}
case 221:
#line 1357 "gram.y"
{
		  out_form (", %s, ", yyvsp[0].value > 0 ? "<=" : ">=");
		;
    break;}
case 222:
#line 1361 "gram.y"
{
		  out_s (")\n");
		  extra_indent++;
		;
    break;}
case 223:
#line 1366 "gram.y"
{
		  extra_indent--;
		  out_form ("_C4P_FOR_END (%s, %s)\n",
			    yyvsp[-9].sym->s_repr,
			    yyvsp[-5].value > 0 ? "++" : "--");
		;
    break;}
case 224:
#line 1376 "gram.y"
{
		;
    break;}
case 225:
#line 1382 "gram.y"
{
		;
    break;}
case 226:
#line 1388 "gram.y"
{
		  yyval.value = 1;
		;
    break;}
case 227:
#line 1392 "gram.y"
{
		  yyval.value = -1;
		;
    break;}
case 228:
#line 1399 "gram.y"
{
		  if (last_type == FUNCTION_TYPE)
		    out_s ("_c4p_result = ");
		  else
		    out_s (" = ");
		;
    break;}
case 229:
#line 1406 "gram.y"
{
		  if (buf_mark2 != NO_MARK)
		    out_buf_over (buf_mark2, "w", 1);
		;
    break;}
case 230:
#line 1411 "gram.y"
{
		  out_s (";\n");
		;
    break;}
case 231:
#line 1418 "gram.y"
{
		  out_form ("goto _c4p_L%ld;\n", yyvsp[0].value);
		;
    break;}
case 236:
#line 1438 "gram.y"
{
		  if (last_type != FILE_NODE)
		    c4p_error ("left side of `^' must be a file variable");
		  out_s ("._c4p_buf");
		  last_type = ((file_node *) last_type_ptr)->type;
		  last_type_ptr = ((file_node *) last_type_ptr)->type_ptr;
		;
    break;}
case 238:
#line 1453 "gram.y"
{
		  switch (yyvsp[0].sym->s_kind)
		    {
		    case VARIABLE_IDENTIFIER:
		    case PARAMETER_IDENTIFIER:
		    case CONSTANT_IDENTIFIER:
		      last_type = yyvsp[0].sym->s_type;
		      last_type_ptr = yyvsp[0].sym ->s_type_ptr;
		      if (yyvsp[0].sym->s_flags & S_BY_REFERENCE)
			out_form ("(*%s)", yyvsp[0].sym->s_repr);
		      else if (yyvsp[0].sym->s_flags & S_FAST)
			{
			  out_form ("_c4p_fast_%s_%u", yyvsp[0].sym->s_repr, routine_handle);
			  remember_fast_var (yyvsp[0].sym->s_repr);
			}
		      else
			out_s (yyvsp[0].sym->s_repr);
		      break;
		    case FUNCTION_IDENTIFIER:
		      last_type = FUNCTION_TYPE;
		      last_type_ptr = yyvsp[0].sym->s_type_ptr;
		      break;
		    default:
		      c4p_error ("`%s' isn't defined", yyvsp[0].sym->s_repr);
		      break;
		    }
		;
    break;}
case 241:
#line 1489 "gram.y"
{
		  if (last_type != ARRAY_NODE)
		    c4p_error ("left side of `[' must be an array variable");
		  out_s ("[ ");
		  yyval.value = 0;
		  push_array_type (last_type_ptr);
		;
    break;}
case 242:
#line 1497 "gram.y"
{
		  last_type = last_array_node->component_type;
		  last_type_ptr = last_array_node->component_type_ptr;
		  pop_array_type ();
		  out_s (" ]");
		;
    break;}
case 244:
#line 1511 "gram.y"
{
		  last_type = translate_field_name (yyvsp[0].sym->s_repr,
						    last_type_ptr,
						    &last_type_ptr);
		;
    break;}
case 246:
#line 1524 "gram.y"
{
                  if (last_array_node->lower_bound != 0)
		    out_form (" - (%ld)", get_array_offset (last_array_node));
		  last_type = last_array_node->component_type;
		  last_type_ptr = last_array_node->component_type_ptr;
		;
    break;}
case 247:
#line 1531 "gram.y"
{
		  out_s (" ][ ");
		;
    break;}
case 248:
#line 1535 "gram.y"
{
		  last_array_node = last_array_node->component_type_ptr;
		  out_form (" - (%ld)",	get_array_offset (last_array_node));
		  last_type = last_array_node->component_type;
		  last_type_ptr = last_array_node->component_type_ptr;
		;
    break;}
case 250:
#line 1546 "gram.y"
{
		  yyval.buf_mark = get_buf_mark ();
		  out_s ("(integer)  ");
		;
    break;}
case 251:
#line 1551 "gram.y"
{
		  yyval.value = (long) coerce ((unsigned) yyvsp[-3].value, (unsigned) yyvsp[0].value);
		  if (yyval.value == REAL_TYPE)
		    out_buf_over (yyvsp[-1].buf_mark, "(real)     ", 11);
		  if (yyval.value == LONG_REAL_TYPE)
		    out_buf_over (yyvsp[-1].buf_mark, "(longreal) ", 11);
		;
    break;}
case 253:
#line 1566 "gram.y"
{
		  out_s (" < ");
		;
    break;}
case 254:
#line 1570 "gram.y"
{
		  out_s (" > ");
		;
    break;}
case 255:
#line 1574 "gram.y"
{
		  out_s (" <= ");
		;
    break;}
case 256:
#line 1578 "gram.y"
{
		  out_s (" >= ");
		;
    break;}
case 257:
#line 1582 "gram.y"
{
		  out_s (" == ");
		;
    break;}
case 258:
#line 1586 "gram.y"
{
		  out_s (" != ");
		;
    break;}
case 260:
#line 1594 "gram.y"
{
		  out_s (" - (integer) ");
		;
    break;}
case 261:
#line 1598 "gram.y"
{
		  yyval.value = yyvsp[0].value;
		;
    break;}
case 262:
#line 1602 "gram.y"
{
		  yyval.value = yyvsp[0].value;
		;
    break;}
case 263:
#line 1606 "gram.y"
{
		  yyval.buf_mark = get_buf_mark ();
		  out_s ("(integer)  ");
		;
    break;}
case 264:
#line 1611 "gram.y"
{
		  yyval.value = (long) coerce ((unsigned) yyvsp[-3].value, (unsigned) yyvsp[0].value);
		  if (yyval.value == REAL_TYPE)
		    out_buf_over (yyvsp[-1].buf_mark, "(real)     ", 11);
		  if (yyval.value == LONG_REAL_TYPE)
		    out_buf_over (yyvsp[-1].buf_mark, "(longreal) ", 11);
		;
    break;}
case 265:
#line 1619 "gram.y"
{
		  out_s (" || ");
		;
    break;}
case 267:
#line 1627 "gram.y"
{
		  out_s (" - ");
		;
    break;}
case 268:
#line 1631 "gram.y"
{
		  out_s (" + ");
		;
    break;}
case 270:
#line 1639 "gram.y"
{
		  out_s (" / (real) ");
		;
    break;}
case 272:
#line 1644 "gram.y"
{
		  yyval.buf_mark = get_buf_mark ();
		  out_s ("(integer)  ");
		;
    break;}
case 273:
#line 1649 "gram.y"
{
		  yyval.value = (long) coerce ((unsigned) yyvsp[-3].value, (unsigned) yyvsp[0].value);
		  if (yyval.value == REAL_TYPE)
		    out_buf_over (yyvsp[-1].buf_mark, "(real)     ", 11);
		  if (yyval.value == LONG_REAL_TYPE)
		    out_buf_over (yyvsp[-1].buf_mark, "(longreal) ", 11);
		;
    break;}
case 274:
#line 1657 "gram.y"
{
		  out_s (" && ");
		;
    break;}
case 276:
#line 1665 "gram.y"
{
		  out_s (" * ");
		;
    break;}
case 277:
#line 1669 "gram.y"
{
		  out_s (" / ");
		;
    break;}
case 278:
#line 1673 "gram.y"
{
		  out_s (" % ");
		;
    break;}
case 279:
#line 1680 "gram.y"
{
		  yyval.value = last_type = INTEGER_TYPE;
		  out_form ("%ldl", yyvsp[0].value);
		;
    break;}
case 280:
#line 1685 "gram.y"
{
		  yyval.value = last_type = REAL_TYPE;
		  out_form ("%lf", (double) yyvsp[0].fvalue);
		;
    break;}
case 281:
#line 1690 "gram.y"
{
		  yyval.value = last_type = LONG_REAL_TYPE;
		  out_form ("%lf", (double) yyvsp[0].fvalue);
		;
    break;}
case 282:
#line 1695 "gram.y"
{
		  yyval.value = last_type = STRING_TYPE;
		  out_s ("\"");
		  translate_string (get_string ((STRING_PTR) yyvsp[0].value));
		  out_s ("\"");
		;
    break;}
case 283:
#line 1702 "gram.y"
{
		  yyval.value = last_type = CHARACTER_TYPE;
		  out_s ("\'");
		  translate_char ((int) yyvsp[0].value);
		  out_s ("\'");
		;
    break;}
case 284:
#line 1709 "gram.y"
{
		  if (last_type == FUNCTION_TYPE)
		    {
		      prototype_node * proto = last_type_ptr;
		      if (strcmp (proto->name->s_repr, "eoln") == 0)
			out_s ("eoln(input)");
		      else if (strcmp (proto->name->s_repr, "eof") == 0)
		        out_s ("eof(input)");
		      out_form ("%s ()", proto->name->s_repr);
		      last_type = proto->result_type->s_type;
		      last_type_ptr = proto->result_type->s_type_ptr;
		    }
		  yyval.value = last_type;
		;
    break;}
case 285:
#line 1724 "gram.y"
{
		  if (yyvsp[-1].sym->s_kind != FUNCTION_IDENTIFIER)
		    c4p_error ("`%s' is not a function identifier",
			       yyvsp[-1].sym->s_repr);
		  if (yyvsp[-1].sym->s_type != PROTOTYPE_NODE)
		    c4p_error ("intenal error: `%1' has no type",
			       yyvsp[-1].sym->s_repr);
		  out_form ("%s (", yyvsp[-1].sym->s_repr);
		  push_parameter_node (last_parameter);
		  last_parameter = ((prototype_node * )
				    (yyvsp[-1].sym->s_type_ptr))->formal_parameter;
		;
    break;}
case 286:
#line 1737 "gram.y"
{
		  prototype_node * proto = yyvsp[-4].sym->s_type_ptr;
		  out_s (")");
		  pop_parameter_node (last_parameter);
		  yyval.value = last_type = proto->result_type->s_type;
		  last_type_ptr = proto->result_type->s_type_ptr;
		;
    break;}
case 287:
#line 1748 "gram.y"
{
		  out_s (" (");
		;
    break;}
case 288:
#line 1752 "gram.y"
{
		  out_s (") ");
		  yyval.value = yyvsp[-1].value;
		;
    break;}
case 289:
#line 1757 "gram.y"
{
		  out_s ("! ");
		;
    break;}
case 290:
#line 1761 "gram.y"
{
		  yyval.value = yyvsp[0].value;
		;
    break;}
case 294:
#line 1774 "gram.y"
{
		  out_s (", ");
		;
    break;}
case 296:
#line 1781 "gram.y"
{
		  if (last_parameter != 0)
		     if (last_parameter->by_reference)
		        out_s ("&");
		;
    break;}
case 297:
#line 1787 "gram.y"
{
		  if (last_parameter != 0)
		     last_parameter = last_parameter->next;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 457 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1792 "gram.y"
